c     ********************************************************

      subroutine newphoton(sinti,costi,cost,sinp,cosp,phi,xtot,
     1  ytot,ztot)

c     sample position on star and direction of new photon

      implicit none

      real xran,costi,sinti,cospn,phinew,cosb,sinb,coslp,sinlp,lp,
     1 cost,sint,sinp,phi,xtot,ytot,ztot,cosp
      real ran2

      include 'random.txt'
      include 'nums.txt'

c     sample cosb,sinb, position on star in latitude.
      xran=ran2(i1)
      cosb=1.0-2.0*xran
      sinb=sqrt(1.0-cosb**2)
      
c     sample angle of exit using appropriate limb darkening law.
      if(limb.eq.0) then
c        isotropic intensity, sample from n=mu
         xran=ran2(i1)
         cost=sqrt(xran)
      else
         xran=ran2(i1)
         call darkening(xran,cost)
      end if
      sint=sqrt(1.0-cost*cost)

c     sample phi
      xran=ran2(i1)
      phi=r2p*xran
      cosp=cos(phi)
      sinp=sin(phi)

c     sample azimuthal coord (longitude)
      xran=ran2(i1)
      lp=r2p*xran

c     transform to coordinate system of star
      if(abs(cosb).lt.0.9999999) then
         costi=cost*cosb-sint*sinb*cosp
         if(abs(costi).gt.1.) then
            write(6,*) 'initp: costi gt 1',costi
            if(costi.gt.1.) costi=1.0
            if(costi.lt.-1.) costi=-1.0 
         end if
         sinti=sqrt(1.0-costi**2)
         if(sinti.gt.0.0000001)then
            cospn=(cost-costi*cosb)/(sinti*sinb)
            if(abs(cospn).gt.1.) then
               if (abs(cospn).gt.1.01) 
     1            write(6,*)'cospn gt 1 in initp',cospn
               if (cospn.lt.0.) then
                  cospn=-1.
               else
                  cospn=1.
               end if
            end if
            if(phi.lt.pi) then
               phinew=acos(cospn)
               if(phinew.gt.pi) then
                  write(6,*) 'phinew wrong in initp'
                  write(6,*) 'phinew,pi',phinew,pi
                  phinew=pi
               end if
            else
               phinew=r2p-acos(cospn)
               if(phinew.lt.pi) then
                  write(6,*) 'phinew wrong in initp'
                  write(6,*) 'phinew,pi',phinew,pi
                  phinew=pi
               end if
            end if
         else
            phinew=0.
         end if
         phi=phinew
      else
         if(cosb.lt.0.) costi=-cost
      end if   
      phi=phi+lp
      if(phi.gt.r2p) phi=phi-r2p
      if(phi.lt.0.) write(6,*)'phi lt 0',phi
      if(phi.gt.r2p) write(6,*) 'phi gt 2pi',phi
      sinp=sin(phi)
      cosp=cos(phi)

c     x,y,z in units of stellar radius, add a small amount so
c     numerical precision doesn't place photon beneath surface
      ztot=cosb*rmin*1.0001
      xtot=sinb*cos(lp)*rmin*1.0001
      ytot=sinb*sin(lp)*rmin*1.0001

      return
      end
      

c     **********************************************************
